{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, System.ComponentModel, Borland.Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}

type
 TCouleurBase = (cb_rouge, cb_vert, cb_bleu, cb_jaune, cb_magenta,
                 cb_cyan, cb_blanc, cb_noir);
 TIntensite   = 0..255;
 TCouleur = record
  private
   Fcoul : TCouleurBase;
   FProp : TIntensite;
   function EstPrimaire(a:Tcouleur):boolean;
   function EstSecondaire(a:Tcouleur):boolean;
  public
   property Val : TCouleurBase read FCoul write FCoul;
   property Intensite : TIntensite read FProp write FProp;
   class operator Add(a,b:TCouleur):TCouleur;
   class operator Explicit(a:TCouleur):string;
   class operator Implicit(a:Tcouleur):integer;
  end;

function TCouleur.EstPrimaire(a:Tcouleur):boolean;
begin
 result := (a.Val in [cb_rouge,cb_vert,cb_bleu]);
end;

function TCouleur.EstSecondaire(a:Tcouleur):boolean;
begin
 result := (a.Val in [cb_jaune,cb_magenta,cb_cyan]);
end;

class operator TCouleur.Add(a,b:TCouleur):TCouleur;
begin
 // traitement de l'intensit (non raliste)
 result.Intensite := (integer(a.Intensite)+integer(b.Intensite)) mod 256;
 result.Val := a.Val; // cas du rouge+rouge, vert+vert...
 // couleurs primaires -> secondaires
 if (a.Val=cb_rouge) and (b.Val=cb_vert) then result.Val:= cb_jaune;
 if (a.Val=cb_rouge) and (b.Val=cb_bleu) then result.Val:= cb_magenta;
 if (a.Val=cb_vert) and (b.Val=cb_rouge) then result.Val:= cb_jaune;
 if (a.Val=cb_vert) and (b.Val=cb_bleu) then result.Val:= cb_cyan;
 if (a.Val=cb_bleu) and (b.Val=cb_rouge) then result.Val:= cb_magenta;
 if (a.Val=cb_bleu) and (b.Val=cb_vert) then result.Val:= cb_cyan;
 // etc...
end;

class operator TCouleur.Explicit(a:TCouleur):string;
begin
 case a.Val of
  cb_rouge: result:='rouge';
  cb_vert: result:='vert';
  cb_bleu: result:='bleu';
  cb_jaune: result:='jaune';
  cb_cyan: result:='cyan';
  cb_magenta: result:='magenta';
  else result:='blanc';
 end;
 if a.Intensite=0 then result:='noir';
 if (a.Val=cb_blanc) and (a.Intensite<255) then result:='gris';
 if a.Intensite>127 then result:=result+' intense'
                    else result:=result+' sombre';
end;

class operator TCouleur.Implicit(a:Tcouleur):integer;
begin
 result := a.Intensite;
end;


procedure TForm1.Button1Click(Sender: TObject);
var c1,c2,c3 : TCouleur; i:integer; s:string;
begin
 memo1.clear;
 c1.Val := cb_rouge;
 c1.Intensite := 255;
 c2.Val := cb_vert;
 c2.Intensite := 120;
 i := c2; // traduction implicite
 memo1.Lines.Append('c2 = '+inttostr(i));
 c3 := c1 + c2; // operateur Add
 s := String(c3); // traduction explicite
 memo1.Lines.Append('c1 est : '+String(c1));
 memo1.Lines.Append('c2 est : '+String(c2));
 memo1.Lines.Append('c1+c2 = '+s);
end;

end.
